<?php
rg_log("/inc/admin/users/add");

$uid = 0;
$_user_add = "";
$errmsg = array();

if ($doit == 1) {
	if (!rg_token_valid($db, $sid, $token)) {
		$_user_add .= "Invalid token. Try again.";
		return;
	}

	$xuser = rg_var_str("xuser");
	$realname = rg_var_str("realname");
	$email = rg_var_str("email");
	$xpass = rg_var_str("xpass");
	$is_admin = rg_var_uint("is_admin");
	$disk_quota_mb = rg_var_uint("disk_quota_mb");
	$rights = @rg_rights_a2s($_REQUEST['rights']);
	$session_time = rg_var_uint("session_time");

	do {
		if (rg_user_ok($xuser) !== TRUE) {
			$errmsg[] = "invalid user name (" . rg_user_error() . ")";
			break;
		}

		if (rg_user_pass_ok($xpass) !== TRUE) {
			$errmsg[] = "invalid password (" . rg_user_error() . ")";
			break;
		}

		$_ui = rg_user_info($db, 0, $xuser, "");
		if ($_ui['ok'] != 1) {
			$errmsg[] = "internal error";
			break;
		}

		if ($_ui['exists'] == 1) {
			$errmsg[] = "user already exists";
			break;
		}

		$_u = array();
		$_u['uid'] = 0;
		$_u['username'] = $xuser;
		$_u['realname'] = $realname;
		$_u['email'] = $email;
		$_u['pass'] = $xpass;
		$_u['is_admin'] = $is_admin;
		$_u['disk_quota_mb'] = $disk_quota_mb;
		$_u['rights'] = $rights;
		$_u['session_time'] = $session_time;
		$_u['confirm_token'] = "";
		if (!rg_user_edit($db, $_u)) {
			$errmsg[] = "cannot add user (" . rg_user_error() . ")";
			break;
		}

		// TODO: Send a confirmation e-mail with the password

		$_user_add .= "OK!<br />";
	} while (0);
} else {
	$xuser = "";
	$realname = "";
	$email = "";
	$xpass = "";
	$is_admin = 0;
	$disk_quota_mb = 0;
	$rights = "";
	$session_time = $rg_session_time;
}

$create_mode = 1;
$admin_mode = 1;
$pass_mode = 1;
include($INC . "/admin/users/user.form.php");
$_user_add .= $_form;

?>
