<?php
rg_log("/inc/user/forgot");

$forgot_token = rg_var_re("forgot_token", "/[^A-Za-z0-9]/");
$pass1 = rg_var_str("pass1");
$pass2 = rg_var_str("pass2");

$_forgot = "";

$errmsg = array();

if ($doit == 1) {
	if (strcmp($pass1, $pass2) != 0) {
		$errmsg[] = "Passwords mismatch.";
	} else {
		$r = rg_user_forgot_pass_uid($db, $forgot_token);
		if ($r['ok'] != 1) {
			$_forgot .= "Internal error, try again later.<br />\n";
			return;
		}

		if ($r['uid'] == 0) {
			$_forgot .= "Invalid (or expired) reset pass URL!<br />\n";
			return;
		}

		if (!rg_user_set_pass($db, $r['uid'], $pass1)) {
			$_forgot .= "Internal error, try again later.<br />\n";
			return;
		}

		rg_user_forgot_pass_destroy($db, $r['uid']);
		// auto-login
		if (!rg_user_auto_login($db, $r['uid'], $rg_ui)) {
			$_forgot = rg_template("msg/internal.txt");
			return;
		}

		// redirect to home
		$url = rg_re_userpage($rg_ui);
		rg_redirect($url);
	}
}

include($INC . "/user/forgot.form.php");
$_forgot .= $_forgot_form;

?>
