<?php
rg_log("/inc/user/repo/bug/add/add");

$bug_more = $_more;
$_bug_add = "";
$bug_errmsg = array();

$_x = array();
if ($doit == 0) {
	// defaults
	$_x['title'] = "";
	$_x['body'] = "";
	$_x['state'] = 1;
	$_x['labels'] = "";
	$_x['assigned_to'] = 0;
} else {
	$_x['title'] = rg_var_str("title");
	$_x['body'] = rg_var_str("body");
	$_x['state'] = rg_var_uint("state");
	$_x['labels'] = rg_var_str("labels");
	$_x['assigned_uid'] = 0;

	do {
		if (!rg_token_valid($db, $sid, rg_var_str("token"))) {
			$bug_errmsg[] = "Invalid token. Try again.";
			break;
		}

		if (empty($_x['title'])) {
			$bug_errmsg[] = "Title too short.";
			break;
		}

		if (empty($_x['body'])) {
			$bug_errmsg[] = "Description too short.";
			break;
		}

		if (($_x['state'] < 1) || ($_x['state'] > 3)) {
			$bug_errmsg[] = "State is not valid.";
			break;
		}

		$bug_id = rg_bug_add($db, $ri['repo_id'], $ui['uid'], $_x);
		if ($bug_id === FALSE) {
			$bug_errmsg[] = "Cannot add bug (" . rg_bug_error() . ").";
			break;
		}

		// redirect to bug home
		$url = rg_re_bugpage($rg_ui, $ri, $bug_id);
		rg_redirect($url);
	} while (0);
}

$bug_more = array_merge($bug_more, $_x);
$bug_more['HTML:bug_errmsg'] = rg_template_errmsg($bug_errmsg);
$bug_more['bug_action'] = "Add bug";
$bug_more['rg_action'] = rg_re_post($cop);
$bug_more['rg_form_token'] = rg_token_get($db, $sid);
$bug_more['HTML:state_select'] = rg_bug_state_select($_x['state']);
$_bug_add .= rg_template("repo/bug/bug_add.html", $bug_more);
?>
