<?php
rg_log("/inc/dispatch/dispatch");

switch ($op) {
case 'main':
	$body .= rg_template("main.html", $more);
	break;

case 'login':
	include($INC . "/login/login.php");
	$body .= $_login;
	break;

case 'logout':
	if (rg_sess_destroy($db, $sid, $rg_ui)) {
		include($INC . "/bye/bye.php");
		$body .= $_bye;
	} else {
		$body .= "Cannot log you out. Please clean all cookies"
			. " and restart browser!";
	}
	break;

case 'repo':
	include($INC . "/repo/repo.php");
	$body .= $_repo;
	break;

case 'repopage':
	include($INC . "/repo/repo_page.php");
	$body .= $_repo;
	break;

case 'admin':
	include($INC . "/admin/admin.php");
	$body .= $_admin;
	break;

case 'forgot_link': // forgot pass link
	include($INC . "/user/forgot.php");
	$body .= $_forgot;
	break;

case 'forgot_send': // forgot pass - send mail
	include($INC . "/user/forgot_send.php");
	$body .= $_forgot;
	break;

case 'create_account':
	include($INC . "/user/create.php");
	$body .= $_create;
	break;

case 'confirm':
	include($INC . "/user/confirm.php");
	$body .= $_confirm;
	break;

case 'suggestion':
	include($INC . "/feedback/suggestion.php");
	$body .= $_suggestion;
	break;

case 'repo-page':
	include($INC . "/user/repo-page.php");
	$body .= $_repo_page;
	break;

case 'home-page':
	include($INC . "/user/home-page.php");
	$body .= $_home;
	break;

case 'personal':
	include($INC . "/user/personal.php");
	$body .= $_personal;
	break;

default:
	rg_log("Invalid operation [$op]!");
}

?>
