<?php
rg_log("/inc/repo/repo");

$_repo = "";

if ($rg_ui['uid'] == 0) {
	$_repo .= "You do not have access here!";
	return;
}

$name = rg_var_str("name");
$max_commit_size = rg_var_uint("max_commit_size");
$max_users = rg_var_uint("max_users");
$description = rg_var_str("description");
$master_repo_id = rg_var_uint("master_repo_id");
$rights = isset($_REQUEST['rights']) ? rg_rights_a2s(rg_var_str("rights")) : $rg_repo_rights_default;
$repo_id = rg_var_uint("repo_id");

if (empty($subop))
	$subop = "list";

// menu
$second_menu = array(
	"create_repo" => array(
		"text" => "Create",
		"op" => "create"
		),
	"list_repos" => array(
		"text" => "List",
		"op" => "list"
		),
	"search_repo" => array(
		"text" => "Search",
		"op" => "search"
		)
);

$errmsg = array();

switch ($subop) {
case 'create':
	while ($doit == 1) {
		$_r = rg_repo_create($db, $master_repo_id, $rg_ui, $name,
			$max_commit_size, $description, $rights, $max_users);
		if ($_r === FALSE) {
			$errmsg[] = rg_repo_error();
			break;
		}

		// redirect to repo page
		$url = rg_re_repopage($rg_ui, $name);
		rg_redirect($url);
	}

	$_action = "Create";
	include($INC . "/repo/repo.form.php");
	$_repo .= $_form;
	break;

case 'list':
	$_repo .= rg_repo_list($db, "", $rg_ui);
	break;

case 'search':
	$q = rg_var_str("q");
	$masters = rg_var_uint("masters");

	while ($doit == 1) {
		$_t = rg_repo_search($db, $q, $masters);
		if ($_t === FALSE) {
			$errmsg[] = rg_repo_error();
			break;
		}

		$_repo .= $_t;
		break;
	}

	include($INC . "/repo/search.form.php");
	$_repo .= $_form;
	break;
}

?>
