<?php
require_once($INC . "/sql.inc.php");

function rg_state_set_error($str)
{
	global $rg_state_error;

	$rg_state_error = $str;
}

function rg_state_error()
{
	global $rg_state_error;
	return $rg_state_error;
}

/*
 * Get state
 */
function rg_state_get($db, $var)
{
	$e_var = rg_sql_escape($db, $var);

	$sql = "SELECT value FROM state WHERE var = '$e_var'";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_state_set_error("state: " . rg_sql_error());
		return FALSE;
	}

	$rows = rg_sql_num_rows($res);
	if ($rows == 0) {
		$ret = "";
	} else {
		$row = rg_sql_fetch_array($res);
		$ret = $row['value'];
	}
	rg_sql_free_result($res);

	return $ret;
}

/*
 * Set state
 */
function rg_state_set($db, $var, $value)
{
	$e_var = rg_sql_escape($db, $var);
	$e_value = rg_sql_escape($db, $value);

	if (rg_state_get($db, $var) === "") {
		$sql = "INSERT INTO state (var, value)"
			. " VALUES('$e_var', '$e_value')";
	} else {
		$sql = "UPDATE state SET value = '$e_value'"
			. " WHERE var = '$e_var'";
	}
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_state_set_error("state: " . rg_sql_error());
		return FALSE;
	}
	rg_sql_free_result($res);

	return TRUE;
}
?>
