<?php
rg_log("/inc/user/repo/bug/show");

$_bug_show = "";

$_my_more = $_more;
$_my_more['bug_id'] = $bug_id;

$ibug = rg_bug_info($db, $ri['repo_id'], $bug_id);
if ($ibug === FALSE)
	rg_fatal("Cannot lookup bug!");
if ($ibug['exists'] != 1) {
	$_bug_body .= rg_template("repo/bug/not_found.html", $_my_more);
	return;
}

$_my_more = array_merge($_my_more, $ibug);

// insert?
$doit = rg_var_uint("doit");
$note_errmsg = array();
if ($doit == 0) {
	// default values
	$_my_more['note'] = "";
} else {
	do {
		$token = rg_var_str("token");
		$note = rg_var_str("note");

		if (!rg_token_valid($db, $sid, $token)) {
			$note_errmsg[] = "Invalid token. Try again.";
			break;
		}

		if (empty($note)) {
			$note_errmsg[] = "Cannot be empty";
			break;
		}

		// add note
		$_d = array();
		$_d['note'] = $note;
		$ret = rg_bug_note_add($db, $ri['repo_id'], $bug_id, $rg_ui['uid'], $_d);
		if ($ret === FALSE) {
			$note_errmsg[] = "Cannot add note (" . rg_bug_error() . ")";
			break;
		}

		// prepare form for other note
		$_my_more['note'] = "";
	} while (0);
}

// load labels
$labels = rg_bug_label_get($db, $ri['repo_id'], $bug_id);
if ($labels === FALSE)
	$_my_more['HTML:labels'] = "Cannot load labels!";
else
	$_my_more['HTML:labels'] = rg_bug_label_html($db, $ri['repo_id'], $bug_id);

// load notes
$notes = rg_bug_note_list($db, $ri['repo_id'], $bug_id, 0);
if ($notes === FALSE)
	$_my_more['HTML:notes'] = "Cannot load notes!";
else
	$_my_more['HTML:notes'] = rg_template_table("repo/bug/list_note", $notes, $_my_more);

// add note form
$_my_more['HTML:note_errmsg'] = rg_template_errmsg($note_errmsg);

$_my_more['rg_action'] = rg_re_post($cop);
$_my_more['rg_form_token'] = rg_token_get($db, $sid);
$_my_more['HTML:note_add'] = rg_template("repo/bug/note_add.html", $_my_more);

$_bug_show .= rg_template("repo/bug/show.html", $_my_more);
?>
