<?php
rg_log("/inc/user/repo/rights/rights");

$target_user = rg_var_str("target_user");
$rights = rg_rights_a2s(rg_var_str("rights"));
$remove_uid = rg_var_uint("remove_uid");
$edit_uid = rg_var_uint("edit_uid");

$_rights = "";

// we need it in forms
$repo_id = $ri['repo_id'];

$errmsg = array();

rg_log("\tDEBUG remove_uid=$remove_uid");

while ($remove_uid > 0) {
	$e = rg_repo_rights_set($db, $ri, $remove_uid, "");
	if ($e !== TRUE) {
		$errmsg[] = rg_repo_error();
		break;
	}

	break;
}

while ($edit_uid > 0) {
	$r = rg_repo_rights_get($db, $ri, $edit_uid, 0);
	if ($r['ok'] != 1) {
		$errmsg[] = "User does not exists";
		rg_log("User does not exists (" . rg_repo_error() . ")!");
		break;
	}

	// Find user name
	$target_ui = rg_user_info($db, $edit_uid, "", "");
	if ($target_ui['exists'] != 1) {
		$errmsg[] = "user does not exists anymore";
		break;
	}

	$target_user = $target_ui['username'];
	$rights = $r['rights'];
	break;
}

while ($doit == 1) {
	if (!rg_token_valid($db, $sid, $token)) {
		$errmsg[] = "invalid token; try again";
		return;
	}

	// lookup user
	$_ui = rg_user_info($db, 0, $target_user, "");
	if ($_ui['exists'] != 1) {
		$errmsg[] = "user <b>$target_user</b> does not exists";
		rg_log("User $target_user does not exists (" . rg_repo_error() . ")!");
		break;
	}

	$e = rg_repo_rights_set($db, $ri, $_ui['uid'], $rights);
	if ($e === FALSE) {
		$errmsg[] = rg_repo_error();
		break;
	}

	// no need to pre-fill user beause was just added
	$target_user = "";
	$rights = "";
	break;
}

// list rights
$_rights .= rg_repo_rights_list($db, $ri, $_url_admin . "/rights");

$_rights .= "<br />\n";

include($INC . "/user/repo/rights/rights.form.php");
$_rights .= $_form;
?>
